#########
#
# Copyright (c) 2005 Dan B Goldman
# 
# This file is part of the vignette-removal library.
#
# Vignette-removal is free software; you can redistribute it and/or modify
# it under the terms of the X11 Software License (see the LICENSE file
# for details).
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the X11
# License for more details.
#
#########

from numarray import *
UInt8 = 'UInt8'
import Image

def array2image(a,scale=1):
    error = 'array2image.error'
    if len(a.shape) == 2:
        imtype = 'L'
    elif len(a.shape) == 3:
        if a.shape[2] == 3:
            imtype = 'RGB'
        elif a.shape[2] == 4:
            imtype = 'RGBA'
        else:
            raise error, "wrong dimensions for image"
    else:
        raise error, "wrong dimensions for image"

    data = minimum(a*scale,255.0)
    data = transpose(data.astype(UInt8),(1,0,2)).tostring()
    size = a.shape[:2]
    return Image.fromstring(imtype,size,data)

def image2array(i):
    size = (i.size[1],i.size[0])
    a = reshape(array(i.tostring(),UInt8),
                size+(len(i.mode),))
    return transpose(a,(1,0,2))
